Copy files to and from a remote host using scp.

Use Project#createTask to register a new Task.

author | Michiel Rook
author | Johan Van den Brande
version | $Id: 300efdab5b721c6312491450bc2ba93ffc8124b4 $
package | phing.tasks.ext
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Nested creator, creates a FileSet for this task

    createFileSet() : \FileSet

### Returns

`\FileSet`The created fileset object

## Returns whether to autocreate remote directories

    getAutocreate()

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()

### Returns

`string`The text description of the task

## Returns whether to send (default) or fetch files

    getFetch()

## Returns local filename

    getFile()

## Returns the remote host

    getHost()

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the mode value

    getMode()

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns the password

    getPassword()

## Returns the remote host port

    getPort()

## Returns the private keyfile

    getPrivkeyfile()

## Returns the private keyfile passphrase

    getPrivkeyfilepassphrase($privkeyfilepassphrase)

### Parameters

#### $privkeyfilepassphrase

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the pubkeyfile

    getPubkeyfile()

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Returns the destination directory

    getTodir()

## Returns the username

    getUsername()

## Called by the parser to let the task initialize properly.

    init()

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Called by the project to let the task do it's work.

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()

## Sets whether to autocreate remote directories

    setAutocreate($autocreate)

### Parameters

#### $autocreate

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Sets whether to send (default) or fetch files

    setFetch($fetch)

### Parameters

#### $fetch

## Sets local filename

    setFile($file)

### Parameters

#### $file

## Sets the remote host

    setHost($h)

### Parameters

#### $h

## Set level of log messages generated (default = verbose)

    setLevel(string $level)

### Parameters

#### $level

`string`

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the mode value

    setMode($value)

### Parameters

#### $value

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## Sets the password of the user to scp

    setPassword($password)

### Parameters

#### $password

## Sets the remote host port

    setPort($p)

### Parameters

#### $p

## Sets the private key file of the user to scp

    setPrivkeyfile($privkeyfile)

### Parameters

#### $privkeyfile

## Sets the private key file passphrase of the user to scp

    setPrivkeyfilepassphrase($privkeyfilepassphrase)

### Parameters

#### $privkeyfilepassphrase

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Sets the public key file of the user to scp

    setPubkeyfile($pubkeyfile)

### Parameters

#### $pubkeyfile

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Set destination directory

    setTodir($todir)

### Parameters

#### $todir

## Sets the username of the user to scp

    setUsername($username)

### Parameters

#### $username

## copyFile()

    copyFile($local, $remote)

### Parameters

#### $local

#### $remote

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()

### Parameters

#### $slotName

`string`

### Properties

##

    $autocreate

##

    $connection

##

    $count

##

    $description : string

Inherited

inherited_from | \Task::$$description

##

    $fetch

##

    $file

##

    $filesets

##

    $host

##

    $localEndpoint

##

    $location : \Location

Inherited

inherited_from | \Task::$$location

##

    $logLevel

##

    $mode

##

    $password

##

    $port

##

    $privkeyfile

##

    $privkeyfilepassphrase

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project

##

    $pubkeyfile

##

    $remoteEndpoint

##

    $sftp

##

    $target : \Target

Inherited

inherited_from | \Task::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType

##

    $todir

##

    $username

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper